
#include <stdio.h>
#include <stdlib.h>
#include "ch3d.h"

#ifndef	WITH_DGF
#define NV	Nv1
#define NF	Nf1
#else
#define NV	Nv2
#define NF	Nf2
#endif

#define EPS	1e-5
#define WID	((long double)CH3D_MAX-(long double)CH3D_MIN)

int	main()
{
	unsigned long	np;
	CH3D_U		Np,p,vf,P[3];
	double		*x,*y,*z,x1,x2,y1,y2,z1,z2,dx,dy,dz,x0,y0,z0;
	CH3D_T		*ch3d;

	if (scanf("%lu",&np)!=1 || (Np=(CH3D_U)np)<4 ||
	    (x=(double *)malloc(sizeof(double)*Np))==NULL ||
	    (y=(double *)malloc(sizeof(double)*Np))==NULL ||
	    (z=(double *)malloc(sizeof(double)*Np))==NULL) exit(1);

	for (p=0; p<Np; p++) {
	    if (scanf("%lf %lf %lf",x+p,y+p,z+p)!=3) exit(1);

	    if (p==0) {
		x1=x2=x[p]; y1=y2=y[p]; z1=z2=z[p];
	    }
	    else {
		if (x1>x[p]) x1=x[p]; else if (x2<x[p]) x2=x[p];
		if (y1>y[p]) y1=y[p]; else if (y2<y[p]) y2=y[p];
		if (z1>z[p]) z1=z[p]; else if (z2<z[p]) z2=z[p];
	    }
	}
	if ((dx=x2-x1)<EPS || (dy=y2-y1)<EPS || (dz=z2-z1)<EPS) exit(1);

	ch3d=InitCH3D(Np);

	x0=(x1+x2)/2.0; y0=(y1+y2)/2.0; z0=(z1+z2)/2.0;
	for (p=0; p<Np; p++) {
	    CH3D_X(ch3d)[p]=(CH3D_I)(WID*((x[p]-x0)/dx));
	    CH3D_Y(ch3d)[p]=(CH3D_I)(WID*((y[p]-y0)/dy));
	    CH3D_Z(ch3d)[p]=(CH3D_I)(WID*((z[p]-z0)/dz));
	}
	CH3D(ch3d,Np,0);

	(void)printf("%lu\t%lu\n",(unsigned long)ch3d->NV,
				  (unsigned long)ch3d->NF);

	for (vf=0; vf<ch3d->NV; vf++) {
	    p=CH3D_V2P(ch3d,vf);
	    (void)printf("%lf\t%lf\t%lf\t"
			 "%ld\t%ld\t%ld\n",x[p],y[p],z[p],
					   (long)CH3D_X(ch3d)[p],
					   (long)CH3D_Y(ch3d)[p],
					   (long)CH3D_Z(ch3d)[p]);
	}
	for (vf=0; vf<ch3d->NF; vf++) {
	    CH3D_f2p(ch3d,vf,P);
	    (void)printf("%lu\t%lu\t%lu\n",
			 (unsigned long)CH3D_P2V(ch3d,P[0]),
			 (unsigned long)CH3D_P2V(ch3d,P[1]),
			 (unsigned long)CH3D_P2V(ch3d,P[2]));
	}
	TermCH3D(ch3d); free(z); free(y); free(x); return 0;
}
