
#include <stdio.h>
#include <stdlib.h>

extern void	chull3_();

static int	Int(f)
float		f;
{
	int	i=(int)f;

	return ((float)i>f)?i-1:i;
}

#define IXYMAX	((1<<28)-1)

int	main()
{
	int	nofp,n1,n2,n3,*ix,*iy,*iz,*name,
		*kve,*kfe,*ksv,*kev,*krf,*klf,*ksce,*kscce,*kece,*kecce,
		*kwv1,*kwv2,*kwv3,*kwv4,*kwv5,*kwv6,*kwe1,*kwe2,*kwf1,*kwf2,
		i,kpara[10],nv,nf,ie,iv1,iv2,iv3;
	float	*x,*y,*z,xyz1,xyz2,xyz3,xyz4;

	if (scanf("%d",&nofp)!=1 || nofp<=0) {
	    (void)fputs("bad number of vertices.\n",stderr); exit(1);
	}
	n1=nofp+1; n2=n1*3; n3=n1*4;

#define ALLOC0(x)	(x=(float *)malloc(sizeof(float)*n1))==NULL
#define ALLOC1(ix)	(ix=(int *)malloc(sizeof(int)*n1))==NULL
#define ALLOC2(kfe)	(kfe=(int *)malloc(sizeof(int)*n2))==NULL
#define ALLOC3(ksv)	(ksv=(int *)malloc(sizeof(int)*n3))==NULL

	if (ALLOC0(x) || ALLOC0(y) || ALLOC0(z) ||
	    ALLOC1(ix) || ALLOC1(iy) || ALLOC1(iz) || ALLOC1(name) ||
	    ALLOC1(kve) || ALLOC2(kfe) ||
	    ALLOC3(ksv) || ALLOC3(kev) || ALLOC3(krf) || ALLOC3(klf) ||
	    ALLOC3(ksce) || ALLOC3(kscce) || ALLOC3(kece) || ALLOC3(kecce) ||
	    ALLOC1(kwv1) || ALLOC1(kwv2) || ALLOC1(kwv3) || ALLOC1(kwv4) ||
	    ALLOC1(kwv5) || ALLOC1(kwv6) ||
	    ALLOC3(kwe1) || ALLOC3(kwe2) ||
	    ALLOC2(kwf1) || ALLOC2(kwf2)) {
	    (void)fputs("memory allocation error.\n",stderr); exit(1);
	}
	for (i=0; i<nofp; i++) {
	    if (scanf("%f %f %f",x+i,y+i,z+i)!=3) {
		(void)fputs("vertex data read error.\n",stderr); exit(1);
	    }
	    if (i==0) xyz1=xyz2=x[0]; else
	    if (x[i]<xyz1) xyz1=x[i]; else if (x[i]>xyz2) xyz2=x[i];
	    if (y[i]<xyz1) xyz1=y[i]; else if (y[i]>xyz2) xyz2=y[i];
	    if (z[i]<xyz1) xyz1=z[i]; else if (z[i]>xyz2) xyz2=z[i];
	}
	xyz3=(xyz1+xyz2)/2.0; xyz4=(float)IXYMAX/(xyz2-xyz1);
	for (i=0; i<nofp; i++) {
	    ix[i]=Int((x[i]-xyz3)*xyz4);
	    iy[i]=Int((y[i]-xyz3)*xyz4);
	    iz[i]=Int((z[i]-xyz3)*xyz4); name[i]=i;
	}
	kpara[0]=n1;
	chull3_(&nofp,ix,iy,iz,name,kpara,
		kve,kfe,ksv,kev,krf,klf,ksce,kscce,kece,kecce,
		kwv1,kwv2,kwv3,kwv4,kwv5,kwv6,kwe1,kwe2,kwf1,kwf2);

	nv=0;
	for (i=0; i<n1; i++) {
	    kwv6[i]=nv; nv+=kwv5[i];
	}
	nf=0; for (i=0; i<n2; i++) nf+=kwf1[i];

	(void)printf("%d\t%d\n",nv,nf);

	for (i=0; i<n1; i++)
	    if (kwv5[i]) (void)printf("%f\t%f\t%f\n",x[i],y[i],z[i]);

	for (i=0; i<n2; i++)
	    if (kwf1[i]) {
		ie=kfe[i]-1;
		if (i==krf[ie]-1) {
		    iv1=kev[ie]; iv2=ksv[ie]; ie=ksce[ie]-1;
		}
		else {
		    iv1=ksv[ie]; iv2=kev[ie]; ie=kece[ie]-1;
		}
		iv3=(i==krf[ie]-1)?ksv[ie]:kev[ie];

		(void)printf("%d\t%d\t%d\t255\t255\t255\n",
			     kwv6[iv1-1],kwv6[iv2-1],kwv6[iv3-1]);
	    }

	free(kwf2); free(kwf1);
	free(kwe2); free(kwe1);
	free(kwv6); free(kwv5); free(kwv4); free(kwv3); free(kwv2); free(kwv1);
	free(kecce); free(kece); free(kscce); free(ksce);
	free(klf); free(krf); free(kev); free(ksv);
	free(kfe); free(kve);
	free(name); free(iz); free(iy); free(ix);
	free(z); free(y); free(x);

	return 0;
}
