
#define N		624
#define M		397
#define MATRIX_A	0x9908b0df
#define UPPER_MASK	0x80000000
#define LOWER_MASK	0x7fffffff

static unsigned long	mt[N];
static int 		mti=N+1;

void		MT_sRandom(seed)
unsigned int	seed;
{
	mt[0]=(unsigned long)seed&0xffffffff;
	for (mti=1; mti<N; mti++)
	    mt[mti]=(1812433253*(mt[mti-1]^(mt[mti-1]>>30))+mti)&0xffffffff;
}

static unsigned long	mag01[2]={0,MATRIX_A};

unsigned int	MT_uRandom()
{
	unsigned long	y;
	int		kk;

	if (mti>=N) {
	    if (mti==N+1) MT_sRandom((unsigned int)5489);

	    for (kk=0; kk<N-M; kk++) {
		y=(mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
		mt[kk]=mt[kk+M]^(y>>1)^mag01[y&1];
	    }
	    for (; kk<N-1; kk++) {
		y=(mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
		mt[kk]=mt[kk+(M-N)]^(y>>1)^mag01[y&1];
	    }
	    y=(mt[N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
	    mt[N-1]=mt[M-1]^(y>>1)^mag01[y&1];
	    mti=0;
	}
	y=mt[mti++];
	y^=(y>>11); y^=(y<< 7)&0x9d2c5680;
		    y^=(y<<15)&0xefc60000; return (unsigned int)(y^(y>>18));
}
