
#include <stdio.h>
#include "mt.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	int		seed;
	double		lower,upper;
	unsigned long	count;

	if (argc!=5) Error("usage : rng seed lower upper count");

	if (sscanf(argv[1],"%d",&seed)!=1 || seed==0) Error("bad seed.");

	if (sscanf(argv[2],"%lf",&lower)!=1 ||
	    sscanf(argv[3],"%lf",&upper)!=1 ||
	    lower>=upper) Error("bad lower and/or upper limit.");

	if (sscanf(argv[4],"%lu",&count)!=1) Error("bad count.");

	MT_sRandom(seed);

	upper=(upper-lower)/4294967296.0;

	do
	    (void)printf("%lf\n",lower+upper*(double)MT_uRandom());
	while (--count!=0);

	return 0;
}
